unit UnidadBuscarPasajero;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Mask, DBCtrls;

type
  TformBuscarPasajero = class(TForm)
    Label1: TLabel;
    txtNombre: TEdit;
    bBuscar: TButton;
    gDatos: TGroupBox;
    Label2: TLabel;
    txtPasajero: TDBEdit;
    Label3: TLabel;
    txtCO: TDBEdit;
    Label4: TLabel;
    txtCD: TDBEdit;
    Label5: TLabel;
    txtFV: TDBEdit;
    Label6: TLabel;
    lLineaAerea: TLabel;
    txtLinea: TDBEdit;
    lEmpresaTransporte: TLabel;
    txtEmpresaT: TDBEdit;
    Panel1: TPanel;
    Button1: TButton;
    bCancelar: TButton;
    txtMedioT: TComboBox;
    bVolver: TButton;
    procedure bBuscarClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtMedioTClick(Sender: TObject);
    procedure bVolverClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formBuscarPasajero: TformBuscarPasajero;

implementation

uses UnidadModuloDatos, UnidadMenuPrincipal;

{$R *.dfm}

procedure TformBuscarPasajero.bBuscarClick(Sender: TObject);
begin
  if txtNombre.Text <> '' then
  begin
    //utilizamos la funcin "locate" para realizar la bsqueda
    if md.tPasajero.Locate('nombre_pasajero', txtNombre.Text, []) then
    begin
      //mostramos el panel donde se muestran los datos del pasajero buscado
      gDatos.Visible := true;
      //ampliamos el tamao del formulario
      Height := 323;

      //para el desplegable de Medio de transporte (segn sea A = Areo  T = Terrestre)
      if md.tPasajeroMedio_transporte.AsString = 'A' then
        txtMedioT.ItemIndex := txtMedioT.Items.IndexOf ('Areo');
      if md.tPasajeroMedio_transporte.AsString = 'T' then
        txtMedioT.ItemIndex := txtMedioT.Items.IndexOf ('Terrestre');
    end
    else
    begin
      //ocultamos el panel donde se muestran los datos del pasajero buscado
      gDatos.Visible := False;
      //reducimos el tamao del formulario
      Height := 68;
      MessageDlg('No se ha encontrado ningn pasajero con el nombre especificado.', mtWarning, [mbok], 0);
      txtNombre.SetFocus;
    end;
  end
  else
  begin
    MessageDlg('Debe introducir el nombre del pasajero a buscar.', mtWarning, [mbok], 0);
    txtNombre.SetFocus;
  end;
end;

procedure TformBuscarPasajero.bCancelarClick(Sender: TObject);
begin
  md.tPasajero.Cancel;
  close;
end;

procedure TformBuscarPasajero.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  formmenuprincipal.vtMostrarDatos := false;
  md.tPasajero.Cancel;
  Action := caFree;
end;

procedure TformBuscarPasajero.Button1Click(Sender: TObject);
var
  seguir : boolean;
begin
  //comprobamos que se han introducido todos los datos
  if txtPasajero.Text = '' then
  begin
    MessageDlg('Debe introducir el nombre del pasajero.', mtWarning, [mbok], 0);
    txtPasajero.SetFocus;
  end
  else
  begin
    if txtCO.Text = '' then
    begin
      MessageDlg('Debe introducir la ciudad de origen.', mtWarning, [mbok], 0);
      txtCO.SetFocus;
    end
    else
    begin
      if txtCD.Text = '' then
      begin
        MessageDlg('Debe introducir la ciudad de destino.', mtWarning, [mbok], 0);
        txtCD.SetFocus;
      end
      else
      begin
        if md.tPasajeroFecha_viaje.AsString = '' then
        begin
          MessageDlg('Debe introducir la fecha del viaje.', mtWarning, [mbok], 0);
          txtFV.SetFocus;
        end
        else
        begin
          if txtMedioT.Text = '' then
          begin
            MessageDlg('Debe introducir el medio de transporte.', mtWarning, [mbok], 0);
            txtMedioT.SetFocus;
          end
          else
          begin
            seguir := true;
            if (txtMedioT.Text = 'Terrestre') and (txtEmpresaT.Text = '') then
            begin
              seguir := false;
              MessageDlg('Debe introducir la empresa de transporte.', mtWarning, [mbok], 0);
              txtEmpresaT.SetFocus;
            end;
            if (txtMedioT.Text = 'Areo') and (txtLinea.Text = '') and (seguir = true) then
            begin
              seguir := false;
              MessageDlg('Debe introducir la lnea area.', mtWarning, [mbok], 0);
              txtLinea.SetFocus;
            end;
            if seguir then
            begin
              if txtMedioT.Text = 'Areo' then
                md.tPasajeroMedio_transporte.Value := 'A';
              if txtMedioT.Text = 'Terrestre' then
                md.tPasajeroMedio_transporte.Value := 'T';
              md.tPasajero.Post;
              Close;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TformBuscarPasajero.FormCreate(Sender: TObject);
begin
  //ocultamos el panel donde se muestran los datos del pasajero buscado
  gDatos.Visible := False;
  //reducimos el tamao del formulario
  Height := 68;

  //si se ha hecho doble clic sobre algn pasajero del formulario principal lo mostramos directamente
  if formMenuPrincipal.vtMostrarDatos then
  begin
    gDatos.Visible := true;
    Height := 323;
  end;
end;

procedure TformBuscarPasajero.txtMedioTClick(Sender: TObject);
begin
  if txtMedioT.Text = 'Terrestre' then
  begin
    txtLinea.Text := '';
    txtLinea.Enabled := false;
    lLineaAerea.Enabled := false;
    lEmpresaTransporte.Enabled := true;
    txtEmpresaT.Enabled := true;
  end;
  if txtMedioT.Text = 'Areo' then
  begin
    txtEmpresaT.Text := '';
    txtEmpresaT.Enabled := false;
    lEmpresaTransporte.Enabled := false;
    lLineaAerea.Enabled := true;
    txtLinea.Enabled := true;
  end;
end;

procedure TformBuscarPasajero.bVolverClick(Sender: TObject);
begin
  close;
end;

end.
